{ Sfaizst » 2/4/2018, 01:44 Re: Tutorial Arduino programmieren,
 Seite 7

 Unterstützt das RTC Modul DSS3231 welches über I2C angebunden ist.
}

unit avr_rtc_ds3231;

{$mode objfpc}{$H+}

interface

uses
  avr_twi;

type
  Trtc_Time = record
    s: Byte;
    m: Byte;
    h: Byte;
    mday: Byte;  //Monatstag
    wday: Byte;  //Wochentag
    mon: Byte;   //Monat
    year: Int16;  //Jahr (0..99)
  end;

  { TAVR_RTC_DS3231 }
  TAVR_RTC_DS3231 = object
  private
  public
    Device_Addr:byte;
    constructor Create(ADevice_Addr: byte);
    destructor Destroy;

    function rtc_recv(var ATime: Trtc_Time): Boolean;
    function rtc_send(ATime: Trtc_Time): Boolean;
  end; // TAVR_RTC_DS3231

implementation

function dec2bcd(ADec: Byte): Byte;
begin
  Result := ((ADec div 10 * 16) + (ADec mod 10));
end;

function bcd2dec(ABcd: Byte): Byte;
begin
  Result := ((ABcd div 16 * 10) + (ABcd mod 16));
end;

function TAVR_RTC_DS3231.rtc_recv(var ATime: Trtc_Time): Boolean;
var
  I: Byte;
  Recv: Array [0..7] of Byte;
begin
  Result := TWIStart((Device_Addr shl 1) or TWI_Write);
  If Result = True then
    begin
      TWIWrite($0);
      TWIStop;
      Result := TWIStart((Device_Addr shl 1) or TWI_Read);
      If Result = True then
        begin
          for I := 0 to 5 do
              Recv[I] := TWIReadACK;
          Recv[6] := TWIReadNACK;
          TWIStop;
          ATime.s := Bcd2dec(Recv[0] and $7F);
          ATime.m := Bcd2dec(Recv[1] and $7F);
          ATime.h := Bcd2dec(Recv[2] and $7F);
          ATime.wday := Bcd2dec(Recv[3]);
          ATime.mday := Bcd2dec(Recv[4]);
          ATime.mon := Bcd2dec(Recv[5] and $1F);
          ATime.year:= 2000+Bcd2dec(Recv[6]);

       {   I := (Recv[5] and $80) shr 7;
          If I = 1 then
            ATime.year := 2000 + bcd2dec(Recv[6]) Else
            ATime.year := 1900 + bcd2dec(Recv[6]);}
        end;
    end;
end;


function TAVR_RTC_DS3231.rtc_send(ATime: Trtc_Time): Boolean;
var
  I: Byte;
  Send: Array [0..6] of Byte;
begin
  Result := TWIStart((Device_Addr shl 1) or TWI_Write);
  If Result = True then
    begin
      TWIWrite($0);
      Send[0] := Dec2Bcd(ATime.s);
      Send[1] := Dec2Bcd(ATime.m);
      Send[2] := Dec2Bcd(ATime.h);
      Send[3] := Dec2Bcd(ATime.wday);
      Send[4] := Dec2Bcd(ATime.mday);
      If ATime.year >= 2000 then
        begin
          I := $80;
          Send[6] := ATime.year - 2000;
        end Else
        begin
          I := $0;
          Send[6] := ATime.year - 1900;
        end;
      Send[5] := Dec2Bcd(ATime.mday)+I;
      for I := 0 to 6 do
        TWIWrite(Send[I]);
      TWIStop;
    end;
end;

{ TAVR_RTC_DS3231 }

constructor TAVR_RTC_DS3231.Create(ADevice_Addr: byte);
begin
  Device_Addr:=ADevice_Addr;
  TWIInit;
end; // TAVR_RTC_DS3231.Create

destructor TAVR_RTC_DS3231.Destroy;
begin

end; // TAVR_RTC_DS3231.Destroy

end.
