{
  Autor: Michael Springwald
  Datum: Montag, der 27.08.2018

  Test Programm für ein:
  AM2320 Sensor - Mist Temperatur und Luftfeuchtigkeit über I2C
  DS3231 RTC - Hier kann die Aktuelle Uhrzeit und das Aktuelle Datum abgefragt werden
  LCD 2004 - Die Infos von den Sensor und dem RTC kommen hierdrauf

  project1.pas(24,59) Warning: Calling convention directive ignored: "OldFPCCall"

}


program project1;
{$H-}

uses avr_uart, avr_gripo, avr_twi, avr_sensor_am2320, avr_rtc_ds3231, avr_lcd_2004;

const
  dl  = 250000+250000+250000+250000; // ca 2 Sekunden

var
  Digit:String[4]; // Werte der einzelnen Digits
  Millis:LongInt = 0;

procedure Timer2_Interrupt; public Name 'TIMER2_OVF_ISR'; interrupt;
const
  zaehler: integer = 0;
  cl =16000000 div 1024 div 1000; // 16'000'000Hz / Clock / TCNT / 2 = 0,5Sek
//   cl = 16384 shr 1;
  // div 1024 div 500
begin
//  TCNT2 := 240;
  Inc(zaehler);
  if zaehler = cl then begin
    inc(Millis);
  end;

  if zaehler >= cl shl 1 then begin
    zaehler := 0;
  end;
end;

procedure Timer0_Interrupt; public Name 'TIMER0_OVF_ISR'; interrupt;
const
  zaehler: integer = 0;
//  64 * 256
  cl = 16000000 div 1024 div 15600; // 16'000'000Hz / Clock / TCNT / 2 = 0,5Sek
begin
  Millis:=Millis+1;
{  Inc(zaehler);
  if zaehler = cl then begin

//    PORTD := PORTD or %00001000;
  end;
  if zaehler >= cl * 2 then begin
//    PORTD := PORTD and not %00001000;
    zaehler := 0;
  end;}
end;


procedure IntToDigit(val: UInt16);
var
  achr: byte;
  leer: boolean;
begin
  Digit[0] := #4; // Der String ist 4 Zeichen lang, inklusive Dezimalpunkt.

  // Zehner
  achr := 0;
  while (val >= 100) do begin
    Dec(val, 100);
    Inc(achr);
    leer := False;
  end;
  if leer then begin
    achr := 16;
  end;
  Digit[1] := Char(achr+ 48);

  // Einer
  achr := 0;
  while (val >= 10) do begin
    Dec(val, 10);
    Inc(achr);
    leer := False;
  end;
  if leer then begin
    achr := 16;
  end;
  Digit[2] := Char(achr+ 48);

  // Dezimalpunkt
  Digit[3] := '.';

  // Zehntel
  achr := 0;
  while (val >= 1) do begin
    Dec(val);
    Inc(achr);
  end;
  Digit[4] := Char(achr+ 48);
end;

var
  Temp, Hum:UInt16;
  S:String;
  rtcTime:Trtc_Time;

  LCD2004:TAVR_LCD;
  AM2320:TAVR_Sensor_Am2320;
  DS3231:TAVR_RTC_DS3231;
begin
  asm cli end; // Interrupt sperren.

{  // Timer 0
  TCCR0A := %00;               // Normaler Timer
  TCCR0B := %101;              // Clock / 1024
  TIMSK0 := (1 shl TOIE0);     // Enable Timer0 Interrupt.}

  // Timer 2
  TCCR2A := %00;               // Normaler Timer
  TCCR2B := %111;              // Clock / 1024
  TIMSK2 := (1 shl TOIE2);     // Enable Timer2 Interrupt.

  UARTInit;

  TWIInit;
  asm sei end; // Interrupt frei geben.

  ModePortB(5,true);
  Temp:=0; Hum:=0;

  LCD2004.Create($25);
  LCD2004.Clear;

  DS3231.Create($68);
  AM2320.Create($5C);

  S:='';
  repeat
    rtcTime.mday:=0; rtcTime.mon:=0; rtcTime.year:=0;
    rtcTime.h:=0; rtcTime.m:=0; rtcTime.s:=0;

    DS3231.rtc_recv(rtcTime);
//     str(Millis,S);
//     UARTSendString(s+#10);

//    Mylcd.setCursor(0,0 );
//    str(Millis,S);
//    Mylcd.Write(S);

    // Datum
    // Der Tag im Monat
    LCD2004.setCursor(0,1 );
    str(rtcTime.mday,S);
    if rtcTime.mday <=9 then s:='0'+s;
    LCD2004.Write(S+'.');

    // Der Aktuelle Monat
    str(rtcTime.mon,S);
    if rtcTime.mon<=9 then s:='0'+s;
    LCD2004.Write(S+'.');

    // Das Aktuelle Jahr
    str(rtcTime.year,S);
    LCD2004.Write(S + ' ');

    // Die Aktuelle Stunde
    str(rtcTime.h,S);
    if rtcTime.h<=9 then s:='0'+s;
    LCD2004.Write(S+':');

    // Die Aktuelle Minute
    str(rtcTime.m,S);
    if rtcTime.m<=9 then s:='0'+s;
    LCD2004.Write(S+':');

    // Die Aktuelle Sekunde
    str(rtcTime.s,S);
    if rtcTime.s <=9 then s:='0'+s;
    LCD2004.Write(S);

    // Temperatur und Luftfeuchtigkeit
    Temp:=AM2320.readTemp();
    Hum:=AM2320.readHum();

    IntToDigit(Temp);
    LCD2004.setCursor(0,3 );
    LCD2004.Write(Digit + ' *C ');

    IntToDigit(Hum);
    LCD2004.Write(Digit+' %');

    mysleep(dl);
  until 1 = 2;
end.
